// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart' as bloc_base;
import 'package:wyatt_bloc_layout/wyatt_bloc_layout.dart';

abstract class AppBarLayoutCrudScreen<Cubit extends bloc_base.Cubit<CrudState>,
    T> extends CrudCubitScreen<Cubit, T> {
  final String? title;

  const AppBarLayoutCrudScreen({
    this.title,
  });

  @override
  Widget parent(BuildContext context, Widget child) => AppBarLayout(
        title: title ?? 'Title',
        body: child,
      );
}

abstract class AppBarLayoutCrudListScreen<
    Cubit extends bloc_base.Cubit<CrudState>,
    T> extends CrudListCubitScreen<Cubit, T> {
  final String? title;
  final int? currentIndex;

  const AppBarLayoutCrudListScreen({
    this.title,
    this.currentIndex,
  });

  @override
  Widget parent(BuildContext context, Widget child) => AppBarLayout(
        title: title ?? 'Title',
        body: child,
      );
}
